subroutine DEALLOCATE_ARRAYS_NormalCirculation()    !  is called in module FluidFlowMain
    USE MudSystemVARIABLES
    implicit none


if(allocated(MudSystem%Xstart_PipeSection)) deallocate(MudSystem%Xstart_PipeSection)  
if(allocated(MudSystem%Xend_PipeSection)) deallocate(MudSystem%Xend_PipeSection)        
if(allocated(MudSystem%PipeSection_VolumeCapacity)) deallocate(MudSystem%PipeSection_VolumeCapacity)        
if(allocated(MudSystem%Area_PipeSectionFt)) deallocate(MudSystem%Area_PipeSectionFt)     
if(allocated(MudSystem%OD_PipeSectionInch)) deallocate(MudSystem%OD_PipeSectionInch)        
if(allocated(MudSystem%ID_PipeSectionInch)) deallocate(MudSystem%ID_PipeSectionInch)   
if(allocated(MudSystem%Xstart_OpSection)) deallocate(MudSystem%Xstart_OpSection)  
if(allocated(MudSystem%Xend_OpSection)) deallocate(MudSystem%Xend_OpSection)        
if(allocated(MudSystem%Area_OpSectionFt)) deallocate(MudSystem%Area_OpSectionFt)        
if(allocated(MudSystem%OD_OpSectionInch)) deallocate(MudSystem%OD_OpSectionInch)        
if(allocated(MudSystem%ID_OpSectionInch)) deallocate(MudSystem%ID_OpSectionInch)        
if(allocated(MudSystem%OpSection_VolumeCapacity)) deallocate(MudSystem%OpSection_VolumeCapacity)  
if(allocated(MudSystem%GeoTypeOp)) deallocate(MudSystem%GeoTypeOp)        
if(allocated(MudSystem%GeoType)) deallocate(MudSystem%GeoType)        


            call MudSystem%Hz_MudDischarged_Volume%Empty()
            call MudSystem%Hz_Mud_Backhead_X%Empty()
            call MudSystem%Hz_Mud_Backhead_section%Empty()
            call MudSystem%Hz_Mud_Forehead_X%Empty()
            call MudSystem%Hz_Mud_Forehead_section%Empty()
            call MudSystem%Hz_Density%Empty()
            call MudSystem%Hz_RemainedVolume_in_LastSection%Empty()
            call MudSystem%Hz_EmptyVolume_inBackheadLocation%Empty() 
            call MudSystem%Hz_MudOrKick%Empty()                                        
            
                                
            call MudSystem%St_MudDischarged_Volume%Empty()
            call MudSystem%St_Mud_Backhead_X%Empty()
            call MudSystem%St_Mud_Backhead_section%Empty()
            call MudSystem%St_Mud_Forehead_X%Empty()
            call MudSystem%St_Mud_Forehead_section%Empty()
            call MudSystem%St_Density%Empty()
            call MudSystem%St_RemainedVolume_in_LastSection%Empty()
            call MudSystem%St_EmptyVolume_inBackheadLocation%Empty()  
            call MudSystem%St_MudOrKick%Empty()                                        
            
                
            call MudSystem%Ann_MudDischarged_Volume%Empty()
            call MudSystem%Ann_Mud_Backhead_X%Empty()
            call MudSystem%Ann_Mud_Backhead_section%Empty()
            call MudSystem%Ann_Mud_Forehead_X%Empty()
            call MudSystem%Ann_Mud_Forehead_section%Empty()
            call MudSystem%Ann_Density%Empty()
            call MudSystem%Ann_RemainedVolume_in_LastSection%Empty()
            call MudSystem%Ann_EmptyVolume_inBackheadLocation%Empty()
            call MudSystem%Ann_MudOrKick%Empty() 
            call MudSystem%Ann_CuttingMud%Empty() 
            
            
            call MudSystem%Op_MudDischarged_Volume%Empty()
            call MudSystem%Op_Mud_Backhead_X%Empty()
            call MudSystem%Op_Mud_Backhead_section%Empty()
            call MudSystem%Op_Mud_Forehead_X%Empty()
            call MudSystem%Op_Mud_Forehead_section%Empty()
            call MudSystem%Op_Density%Empty()
            call MudSystem%Op_RemainedVolume_in_LastSection%Empty()
            call MudSystem%Op_EmptyVolume_inBackheadLocation%Empty()
            call MudSystem%Op_MudOrKick%Empty()                                        
            

            call MudSystem%ChokeLine_MudDischarged_Volume%Empty()
            call MudSystem%ChokeLine_Mud_Backhead_X%Empty()
            call MudSystem%ChokeLine_Mud_Backhead_section%Empty()
            call MudSystem%ChokeLine_Mud_Forehead_X%Empty()
            call MudSystem%ChokeLine_Mud_Forehead_section%Empty()
            call MudSystem%ChokeLine_Density%Empty()
            call MudSystem%ChokeLine_RemainedVolume_in_LastSection%Empty()
            call MudSystem%ChokeLine_EmptyVolume_inBackheadLocation%Empty()
            call MudSystem%ChokeLine_MudOrKick%Empty()  
            
            
        call MudSystem%Xend_MudElement%Empty()
        call MudSystem%Xstart_MudElement%Empty()
        call MudSystem%TVDend_MudElement%Empty()
        call MudSystem%TVDstart_MudElement%Empty()
        call MudSystem%Density_MudElement%Empty()
        call MudSystem%MudGeoType%Empty()
        call MudSystem%PipeID_MudElement%Empty()
        call MudSystem%PipeOD_MudElement%Empty()
        call MudSystem%MudType_MudElement%Empty()            
            
        call MudSystem%Xend_OpMudElement%Empty()
        call MudSystem%Xstart_OpMudElement%Empty()
        call MudSystem%TVDend_OpMudElement%Empty()
        call MudSystem%TVDstart_OpMudElement%Empty()
        call MudSystem%Density_OpMudElement%Empty()
        call MudSystem%PipeID_OpMudElement%Empty()
        call MudSystem%PipeOD_OpMudElement%Empty()
        call MudSystem%MudTypeOp_MudElement%Empty()            
    end subroutine
    
    
    
subroutine RemoveAnnulusMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystem%Ann_MudDischarged_Volume%Remove (ilocal)
                    call MudSystem%Ann_Mud_Backhead_X%Remove (ilocal)
                    call MudSystem%Ann_Mud_Backhead_section%Remove (ilocal)
                    call MudSystem%Ann_Mud_Forehead_X%Remove (ilocal)
                    call MudSystem%Ann_Mud_Forehead_section%Remove (ilocal)
                    call MudSystem%Ann_Density%Remove (ilocal)
                    call MudSystem%Ann_RemainedVolume_in_LastSection%Remove (ilocal)
                    call MudSystem%Ann_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call MudSystem%Ann_MudOrKick%Remove (ilocal)
                    call MudSystem%Ann_CuttingMud%Remove (ilocal)     
    
    
    
    end subroutine
    
    
subroutine RemoveStringMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystem%St_MudDischarged_Volume%Remove (ilocal)
                    call MudSystem%St_Mud_Backhead_X%Remove (ilocal)
                    call MudSystem%St_Mud_Backhead_section%Remove (ilocal)
                    call MudSystem%St_Mud_Forehead_X%Remove (ilocal)
                    call MudSystem%St_Mud_Forehead_section%Remove (ilocal)
                    call MudSystem%St_Density%Remove (ilocal)
                    call MudSystem%St_RemainedVolume_in_LastSection%Remove (ilocal)
                    call MudSystem%St_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call MudSystem%St_MudOrKick%Remove (ilocal)    
    
    
    
    end subroutine    
    
    
subroutine RemoveOpMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystem%Op_MudDischarged_Volume%Remove (ilocal)
                    call MudSystem%Op_Mud_Backhead_X%Remove (ilocal)
                    call MudSystem%Op_Mud_Backhead_section%Remove (ilocal)
                    call MudSystem%Op_Mud_Forehead_X%Remove (ilocal)
                    call MudSystem%Op_Mud_Forehead_section%Remove (ilocal)
                    call MudSystem%Op_Density%Remove (ilocal)
                    call MudSystem%Op_RemainedVolume_in_LastSection%Remove (ilocal)
                    call MudSystem%Op_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call MudSystem%Op_MudOrKick%Remove (ilocal)    
    
    
    
    end subroutine      
    
subroutine RemoveHzMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call MudSystem%Hz_MudDischarged_Volume%Remove (ilocal)
                    call MudSystem%Hz_Mud_Backhead_X%Remove (ilocal)
                    call MudSystem%Hz_Mud_Backhead_section%Remove (ilocal)
                    call MudSystem%Hz_Mud_Forehead_X%Remove (ilocal)
                    call MudSystem%Hz_Mud_Forehead_section%Remove (ilocal)
                    call MudSystem%Hz_Density%Remove (ilocal)
                    call MudSystem%Hz_RemainedVolume_in_LastSection%Remove (ilocal)
                    call MudSystem%Hz_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call MudSystem%Hz_MudOrKick%Remove (ilocal)    
    
    
    
     end subroutine      
   