subroutine TD_HookLoadCalculation
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   Use TD_StringConnectionData
   Use Drawworks_VARIABLES, only: Drawworks
   Use CDataDisplayConsoleVariables
   Use CHoistingVariables
!    Use CSlipsEnumVariables
   use UnitySignalVariables
   Use CBopStackVariables
   Use VARIABLES
   Use CUnityInputs
   
   
   implicit none
   
   Integer :: i , kk
   Real(8) :: TD_eConst=0.98d0 , TD_SumWeight
   
   
   
   
!====================================================
!             Torque & Hook Load Calculation
!====================================================

!=========> HookLoad
  TD_String%HookLoad = TD_DrillStems(TD_String%DrillStemComponentsNumbs)%Force2     ! [lb]
  !print* , 'TD_String%HookLoad1=' , TD_String%HookLoad
  
  if ( Drawworks%motion==1 ) then
      if ( PipeRam1%Situation_forTD==1 ) then  !Upper Ram
          TD_String%HookLoad = TD_String%HookLoad+BopStackSpecification%RamStringDrag
      end if
      if ( PipeRam2%Situation_forTD==1 ) then  !Lower Ram
          TD_String%HookLoad = TD_String%HookLoad+BopStackSpecification%RamStringDrag
      end if
      if ( RamLine%ShearBop_Situation_forTD==1 ) then  !Blind Ram
          TD_String%HookLoad = TD_String%HookLoad+BopStackSpecification%RamStringDrag   !????????????????????
      end if
      if ( Annular%Annular_Situation_forTD==1 ) then   !Annular Preventer
          TD_String%HookLoad = TD_String%HookLoad+(AnnularComputational%p_annular*BopStackSpecification%AnnularStringDrag)
      end if
  else if ( Drawworks%motion==-1 ) then
      if ( PipeRam1%Situation_forTD==1 ) then  !Upper Ram
          TD_String%HookLoad = TD_String%HookLoad-BopStackSpecification%RamStringDrag
      end if
      if ( PipeRam2%Situation_forTD==1 ) then  !Lower Ram
          TD_String%HookLoad = TD_String%HookLoad-BopStackSpecification%RamStringDrag
      end if
      if ( RamLine%ShearBop_Situation_forTD==1 ) then  !Blind Ram
          TD_String%HookLoad = TD_String%HookLoad-BopStackSpecification%RamStringDrag    !????????????????????
      end if
      if ( Annular%Annular_Situation_forTD==1 ) then   !Annular Preventer
          TD_String%HookLoad = TD_String%HookLoad-(AnnularComputational%p_annular*BopStackSpecification%AnnularStringDrag)
      end if
  end if
  
  !print* , 'TD_String%HookLoad2=' , TD_String%HookLoad
  
  
  
  
  
  !if ( UpperRamClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad+RamStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad-RamStringDrag
  !    end if
  !end if
  !if ( LowerRamClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad+RamStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad-RamStringDrag
  !    end if
  !end if
  !if ( BlindRamClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad+RamStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad-RamStringDrag
  !    end if
  !end if
  !if ( AnnularPreventerClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad+AnnularStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_String%HookLoad = TD_String%HookLoad-AnnularStringDrag
  !    end if
  !end if
  
  
  
  
  
  
  
  
!=========> Torque
  TD_String%StringTorque = TD_String%TotalTorque             ![lb.ft]     ??????????
  !print* , 'TD_String%StringTorque=' , TD_String%StringTorque
  
  
  
  
  
!====================================================
!             Weight Indicator Calculation
!====================================================
   
   kk = 0
   Do i = TD_String%DrillStemComponentsNumbs , 1 , -1
           if (TD_DrillStems(i)%ComponentType==3) then
               kk = i
               exit
           end if
   End Do
  
   
   
   
   
   if ( TD_StConn%KellyDriveTypeMode==0 ) then
       
       if ( TD_StConn%StringConnectionMode  == 1 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_Load%WeightTB+TD_Load%KellyWeight
           else
               TD_SumWeight = TD_String%HookLoad+TD_Load%WeightTB+TD_Load%KellyWeight    ! TD_String%HookLoad = String Weight
           end if
       
       else if ( TD_StConn%StringConnectionMode  == 2 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_Load%WeightTB
           else
               TD_SumWeight = TD_Load%WeightTB+TD_Load%KellyWeight
           end if
       
       else if ( TD_StConn%StringConnectionMode  == 3 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_Load%WeightTB
           else
               TD_SumWeight = TD_Load%WeightTB+TD_Load%KellyWeight+TD_DrillStems(kk)%Weight
           end if
           
       end if
       
   else if ( TD_StConn%KellyDriveTypeMode==1 ) then
       
        if ( TD_StConn%StringConnectionMode  == 4 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_Load%WeightTB
           else
               TD_SumWeight = TD_String%HookLoad+TD_Load%WeightTB
           end if
       
        else if ( TD_StConn%StringConnectionMode  == 5 ) then
           TD_SumWeight = TD_Load%WeightTB
       
        else if ( TD_StConn%StringConnectionMode  == 6 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_Load%WeightTB
           else
               TD_SumWeight = TD_Load%WeightTB+(3.d0*TD_DrillStems(kk)%Weight)
           end if
       
        else if ( TD_StConn%StringConnectionMode  == 7 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_Load%WeightTB
           else
               TD_SumWeight = TD_Load%WeightTB+TD_DrillStems(kk)%Weight
           end if
       
        else if ( TD_StConn%StringConnectionMode  == 8 ) then
           TD_SumWeight = TD_Load%WeightTB
           
        else if ( TD_StConn%StringConnectionMode  == 18 ) then
           TD_SumWeight = TD_Load%WeightTB
           
        else if ( TD_StConn%StringConnectionMode  == 19 ) then
           TD_SumWeight = TD_Load%WeightTB
           
        end if
        
   else if ( TD_StConn%KellyDriveTypeMode==2 ) then
       
        if ( TD_StConn%StringConnectionMode  == 9 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_Load%WeightTD
           else
               TD_SumWeight = TD_String%HookLoad+TD_Load%WeightTD
           end if
       
        else if ( TD_StConn%StringConnectionMode  == 10 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_Load%WeightTD
           else
               TD_SumWeight = TD_String%HookLoad+TD_Load%WeightTD
           end if
       
        else if ( TD_StConn%StringConnectionMode  == 11 ) then
           TD_SumWeight = TD_Load%WeightTD
       
        else if ( TD_StConn%StringConnectionMode  == 12 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_Load%WeightTD
           else
               TD_SumWeight = TD_String%HookLoad+TD_Load%WeightTD
           end if
       
        else if ( TD_StConn%StringConnectionMode  == 13 ) then
           TD_SumWeight = TD_Load%WeightTD
       
        else if ( TD_StConn%StringConnectionMode  == 14 ) then
           TD_SumWeight = TD_Load%WeightTD+(3.d0*TD_DrillStems(kk)%Weight)
       
        else if ( TD_StConn%StringConnectionMode  == 15 ) then
           TD_SumWeight = TD_Load%WeightTD+(TD_DrillStems(kk)%Weight)
       
        else if ( TD_StConn%StringConnectionMode  == 16 ) then
           TD_SumWeight = TD_Load%WeightTD
       
        else if ( TD_StConn%StringConnectionMode  == 17 ) then
           TD_SumWeight = TD_Load%WeightTD
           
        end if
    
    end if
    
    
    
    !print* , 'TD_String%HookLoad3=' , TD_String%HookLoad
    
    
    
    
  !if ( Hoisting%DriveType==1 ) then          !==> Kelly_DriveType
  !    
  !    if ( TD_String%DrillStemForceType==1 .or. TD_String%DrillStemForceType==2 ) then
  !        TD_Load%WeightIndicator = ( sngl(TD_Load%NumOfCables)*(TD_eConst-1.d0)*(TD_SumWeight) )&
  !                              /( TD_eConst*(1.d0-(1.d0/(TD_eConst**TD_Load%NumOfCables))) )
  !    else if ( TD_String%DrillStemForceType==3 .or. TD_String%DrillStemForceType==4 ) then
  !        TD_Load%WeightIndicator = ( sngl(TD_Load%NumOfCables)*(1.d0-TD_eConst)*(TD_SumWeight) )&
  !                              /( 1.d0-(TD_eConst**TD_Load%NumOfCables) )
  !    else if ( TD_String%DrillStemForceType==5 ) then
          TD_Load%WeightIndicator = TD_SumWeight
  !    end if
  !    
  !    
  !else if ( Hoisting%DriveType==0 ) then     !==> TopDrive_DriveType   ??????????????
  !    
  !    if ( TD_String%DrillStemForceType==1 .or. TD_String%DrillStemForceType==2 ) then
  !        TD_Load%WeightIndicator = ( sngl(TD_Load%NumOfCables)*(TD_eConst-1.d0)*(TD_SumWeight) )&
  !                              /( TD_eConst*(1.d0-(1.d0/(TD_eConst**TD_Load%NumOfCables))) )
  !    else if ( TD_String%DrillStemForceType==3 .or. TD_String%DrillStemForceType==4 ) then
  !        TD_Load%WeightIndicator = ( sngl(TD_Load%NumOfCables)*(1.d0-TD_eConst)*(TD_SumWeight) )&
  !                              /( 1.d0-(TD_eConst**TD_Load%NumOfCables) )
  !    else if ( TD_String%DrillStemForceType==5 ) then
  !        TD_Load%WeightIndicator = TD_SumWeight
  !    end if
  !    
  !!else
  !!TD_Load%WeightIndicator = 0.  !?????????????????
  !
  !end if
  

  
  
  
 TD_Load%DrawworksLoadInput = TD_Load%WeightIndicator/(sngl(TD_Load%NumOfCables))                 ! [lb]
  !print* , 'TD_String%HookLoad4=' , TD_String%HookLoad
 !HookLoadPointer = TD_Load%WeightIndicator/1.0d3                                       ! [klb]
 call Set_HookLoad ((1-TD_General%WeightIndicatorMalf)*AINT(TD_Load%WeightIndicator/1.0d3))     ! [klb]
  
  
 
 
 
  
end subroutine