MODULE GeoElements_FluidModule
    
    IMPLICIT NONE
    PUBLIC
    
    
    
!************************************************************************************************************************************
    TYPE , PUBLIC :: Geo_Data
        REAL(8) , Allocatable :: MD(:) , TVD(:) , Angle(:)
    END TYPE Geo_Data
    TYPE(Geo_Data) :: TDGeo
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************
!====================================================
!   Well Geometrical Elements Info (for fluid module)
!====================================================
    TYPE , PUBLIC :: F_StringData
        INTEGER :: FirstElement , LastElement , ElType
        REAL(8) :: ID , OD , TopDepth , DownDepth
    END TYPE F_StringData
    TYPE(F_StringData) , Allocatable :: F_String(:)
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************
    TYPE , PUBLIC :: F_IntervalsCountsData
        INTEGER :: IntervalsTotalCounts , StringIntervalCounts , BottomHoleIntervalCounts , AnnulusIntervalCounts
        INTEGER :: OutOfWellIntervalCounts
    END TYPE F_IntervalsCountsData
    TYPE(F_IntervalsCountsData):: F_Counts
!************************************************************************************************************************************
    
    
    
!************************************************************************************************************************************
    TYPE , PUBLIC :: F_IntervalData
        INTEGER :: Number , GeoType
        REAL(8)    :: ID , OD , StartDepth , EndDepth , HydDiameter , Volume
        REAL(8)    :: StartTVD , EndTVD , StartAngle , EndAngle
    END TYPE F_IntervalData
    TYPE(F_IntervalData) , Allocatable :: F_Interval(:)
    !####F_Interval(:)%GeoType = 
    !                           0 : String Interval
    !                           1 : BottomHole Interval
    !                           2 : Annulus Interval
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************
    TYPE , PUBLIC :: OD_AnnulusData
        REAL(8)      :: ODValue , StartMD , EndMD
    END TYPE OD_AnnulusData
    TYPE(OD_AnnulusData) :: OD_Annulus(4)
!************************************************************************************************************************************

    
    
    
    
    
END MODULE GeoElements_FluidModule