MODULE TD_WellElements
    
    IMPLICIT NONE
    PUBLIC

    
    
!************************************************************************************************************************************
    TYPE , PUBLIC :: TD_WellElementsInfo
        INTEGER :: CasingNumbs
        INTEGER :: LinerNumbs
        INTEGER :: OpenHoleNumbs
        INTEGER :: ROPHoleNumbs
        REAL(8) :: ROP
    END TYPE TD_WellElementsInfo
    TYPE(TD_WellElementsInfo) :: TD_WellEl
!************************************************************************************************************************************

    

!************************************************************************************************************************************
!====================================================
!                Casing Info
!====================================================
    TYPE, PUBLIC :: TD_CasingInfo
        INTEGER  :: HoleType
        REAL(8)  :: Length , TopDepth , DownDepth , Od , Id , Weight , CollapsePressure , TensileStrength , Roughness
    END TYPE TD_CasingInfo
    TYPE(TD_CasingInfo), ALLOCATABLE, DIMENSION(:) :: TD_Casing
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************
!====================================================
!                Liner Info
!====================================================
    TYPE, PUBLIC :: TD_LinerInfo
        REAL(8)  :: Length , TopDepth , DownDepth , Od , Id , Weight , CollapsePressure , TensileStrength , Roughness , HoleType
    END TYPE TD_LinerInfo
    TYPE(TD_LinerInfo), ALLOCATABLE, DIMENSION(:)  :: TD_Liner
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************
!====================================================
!                Open_Hole Info
!====================================================
    TYPE, PUBLIC :: TD_OpenHoleInfo
        REAL(8)  :: Length , TopDepth , DownDepth , Id , HoleType
    END TYPE TD_OpenHoleInfo
    TYPE(TD_OpenHoleInfo), ALLOCATABLE, DIMENSION(:) :: TD_OpenHole
!************************************************************************************************************************************

    
    
!************************************************************************************************************************************  
!====================================================
!                ROP_Hole Info
!====================================================
    TYPE, PUBLIC :: TD_ROPHoleInfo
        REAL(8)  :: Length , TopDepth , DownDepth , Id , HoleType
    END TYPE TD_ROPHoleInfo
    TYPE(TD_ROPHoleInfo), ALLOCATABLE, DIMENSION(:) :: TD_ROPHole
!************************************************************************************************************************************

    
    
    
    
    
END MODULE TD_WellElements